local addonName, addon = ...
local L = addon.language

function addon:UpdateConfig(dst, src)
	for k, v in pairs(src) do
		if type(v) == 'table' then
			if type(dst[k]) == 'table' then
				self:UpdateConfig(dst[k], v)
			else
				dst[k] = self:UpdateConfig({}, v)
			end
		elseif type(dst[k]) ~= 'table' then
			dst[k] = v
		end
	end
	return dst
end

function addon:Announce(mode, msg, sound)
	if mode == "off" then
		return
	elseif mode == 'self' then
		print(msg)
		return
	elseif mode == 'instance' then
		mode = 'INSTANCE_CHAT'
	end
	SendChatMessage(msg, mode:upper())
	if sound ~= '' then
		PlaySoundFile(sound, 'MASTER')
	end
end

function addon:Round(number, decimals)
    return (("%%.%df"):format(decimals)):format(number)
end

function addon:SendStats(channel)
	local N = "["..UnitName("player").."]"..L["statsReport"]
	local IL_C = {GetAverageItemLevel()}
	local IL = L["itemLevel"]..string.format("%.1f", IL_C[2])
		
	local S_C = UnitStat("player",1)
	local AG_C = UnitStat("player",2)
	local IN_C = UnitStat("player",4)
	if S_C > AG_C and S_C > IN_C then
		S = " "..L["Strength"]..S_C
	elseif AG_C > S_C and AG_C > IN_C then
		S = " "..L["agility"]..AG_C
	elseif IN_C > S_C and IN_C > AG_C then
		S = " "..L["intelligence"]..IN_C
	end
		
	local A_C = {UnitArmor("player")}
	local A = " "..L["amor"]..A_C[2]
	local CC = " "..L["crit"]..addon:Round(GetCritChance(), 1).."%"
	local H = " "..L["haste"]..addon:Round(GetHaste(), 1).."%"
	local M = " "..L["mastery"]..addon:Round(GetMasteryEffect(), 1).."%"
	local V  = " "..L["versatility"]..addon:Round(GetCombatRatingBonus(29), 1).."%"
	local LS  = " "..L["leech"]..addon:Round(GetCombatRatingBonus(17), 1).."%"
	local DC = " "..L["dodge"]..addon:Round(GetDodgeChance(), 1).."%"
	local PC = " "..L["parry"]..addon:Round(GetParryChance(), 1).."%"
	local BC = " "..L["block"]..addon:Round(GetBlockChance(), 1).."%"
	local END = " "..L["statsEnd"]
	SendChatMessage(N..IL..S..A..CC..H..M..V..LS..DC..PC..BC..END, channel)
end

function addon:QueryAttacking()
	local h = (time()-1545170400)/3600
	local n = math.modf(h/19)%6+1
	local l = h%19
	local a ={L["Zuldazar"],L["TiragardeSound"],L["Nazmir"],L["StormsongValley"],L["Vol'dun"],L["Drustvar"] ,L["Zuldazar"]}
	print(l<7 and string.format(L["attacking"],a[n],7-l) or string.format(L["nextAttack"],a[n+1],19-l))
end



